# Boost.Filesystem

Boost.Filesystem, part of collection of the [Boost C++ Libraries](https://github.com/boostorg), provides facilities to manipulate files and directories, and the paths that identify them.

### Directories

* **doc** - Documentation sources
* **include** - Interface headers of Boost.Filesystem
* **src** - Compilable source files of Boost.Filesystem
* **test** - Boost.Filesystem unit tests
* **example** - Boost.Filesystem usage examples

### More information

* [Documentation](https://boost.org/libs/filesystem)
* [Report bugs](https://github.com/boostorg/filesystem/issues/new). Be sure to mention Boost version, platform and compiler you're using. A small compilable code sample to reproduce the problem is always good as well.
* Submit your patches as pull requests against **develop** branch. Note that by submitting patches you agree to license your modifications under the [Boost Software License, Version 1.0](https://www.boost.org/LICENSE_1_0.txt).

### Build status

Master: [![AppVeyor](https://ci.appveyor.com/api/projects/status/nx3e7bcavvn3q953?svg=true)](https://ci.appveyor.com/project/Lastique/filesystem/branch/master) [![Travis CI](https://travis-ci.org/boostorg/filesystem.svg?branch=master)](https://travis-ci.org/boostorg/filesystem)
Develop: [![AppVeyor](https://ci.appveyor.com/api/projects/status/nx3e7bcavvn3q953/branch/develop?svg=true)](https://ci.appveyor.com/project/Lastique/filesystem/branch/develop) [![Travis CI](https://travis-ci.org/boostorg/filesystem.svg?branch=develop)](https://travis-ci.org/boostorg/filesystem)

### License

Distributed under the [Boost Software License, Version 1.0](https://www.boost.org/LICENSE_1_0.txt).
